#!/usr/bin/pypy 
import game
import time
import subprocess
import json
import sys
import heapq
import signal

starttime=time.time()
AVOST=5
KILLALL=1

params=sys.argv[1:]
phrases=[]
memlimit=0
timelimit=10000
files=[]
corenum=1
parambase=[]
tasks=[]
for i in range(0,len(params),2):
    if params[i]=="-f":
        files.append(params[i+1])
    elif params[i]=="-p":
        phrases.append(params[i+1])
    elif params[i]=="-m":
        memlimit=float(params[i+1])
    elif params[i]=="-t":
        timelimit=float(params[i+1])
    elif params[i]=='-c':
        corenum=int(params[i+1])
    else:
        #pass
        raise Exception("Unknown parameter "+params[i])



for i in files:
    g=game.Games(i)
    complexity=g.board.w*g.board.h*g.source_length
    for j in xrange(g.games_n()):
        tasks+=[(complexity,i,j)]# complexity, file,seedno
heapq.heapify(tasks)
workers=[None]*corenum
output=[]
freed=True;
phrasesparams=[]
for i in phrases:
    phrasesparams.extend(['-p',i])
while 1:
    if timelimit -(time.time()-starttime)>AVOST:
        for i in xrange(corenum):
            if tasks:
                if workers[i]==None:
                    task=heapq.heappop(tasks)
                    workers[i]=[subprocess.Popen(["./lightningsolver.py",'-f',task[1],'-s',`task[2]`]+phrasesparams,stdout=subprocess.PIPE),'running']
        freed=None in workers
    else:
        for i in xrange(corenum):
            if workers[i]!=None and workers[i][1]=='running':
                try:
                    workers[i][0].send_signal(signal.SIGINT)
                except:
                    pass
                workers[i][1]='terminating'
                
        freed=False
    if timelimit -(time.time()-starttime)<KILLALL:
        json.dump(output,sys.stdout)
        print
        for i in xrange(corenum):
            if workers[i]:
                if workers[i][0].poll()==None:
                    try:
                        workers[i][0].kill()
                    except:
                        pass
        sys.exit(0)
    if not freed:
        time.sleep(0.1)
    for i in xrange(corenum):
        if workers[i]:
            if not (workers[i][0].poll() is None):
                o=workers[i][0].stdout.read()
                if o:
                    output.extend(json.loads(o))
                workers[i]=None
                freed=True
    if not tasks and (workers.count(None)==len(workers)):
        break
json.dump(output,sys.stdout)