#!/usr/bin/env python
# coding=utf8
import sys

from util import getch
from game import E, W, SE, SW, CW, CCW, Games

KEY_TO_CMD = {
    'j': W,
    'k': E,
    'n': SW,
    'm': SE,
    'u': CW,
    'i': CCW
}

gs = Games(sys.argv[1])
if gs.games_n() > 1:
    print 'Game count: %d, enter number of game to play:' % gs.games_n()
    game_idx = int(raw_input())
    g = gs.new_game(game_idx)
else:
    print 'Game count: 1'
    g = gs.new_game(0)

i = 0
moves=''
while 1:
    print g.show_with_current_unit()

    key = getch()
    if key == 'f':
        print 'enter command sequence'
        s = raw_input().strip('\n')
        for i, c in enumerate(s):
            res = g.step(c)
            moves+=c
            print g.show_with_current_unit()
            print 'Status: %s, cmd: %s, %d/%d, press any key' % (res, c, i, len(s))
            getch()
        print '------- done'
    if key=='d':
        print g.unit_num,moves
    cmd = KEY_TO_CMD.get(key)

    if cmd is None:
        print 'Supported keys:', KEY_TO_CMD.keys()
        print 'Use "f" to enter command sequence'
        continue
    moves+=cmd
    res = g.step(cmd)
    print 'Status:', res
