#!/usr/bin/env python

import requests
import json,sys

params=sys.argv[1:]

phrases=[]
memlimit=0
timelimit=0
files=[]

for i in range(0,len(params),2):
    if params[i]=="-f":
        files.append(params[i+1])
    elif params[i]=="-p":
        phrases.append(params[i+1])
    elif params[i]=="-m":
        files.append(params[i+1])
    elif params[i]=="-t":
        files.append(params[i+1])
    else:
        raise Exception("Unknown parameter "+params[i])
solutions=[]
for infile in files:
    task=json.load(file(infile))
    for seed in task["sourceSeeds"]:
        solutions.append({"problemId":task["id"],"seed":seed,"tag":"free","solution":"e!"*10})
print json.dumps(solutions)