#!/usr/bin/env python
import json
import requests
from pprint import pprint

r = requests.get('https://davar.icfpcontest.org/rankings.js')
js_data = r.content[11:]
js = json.loads(js_data)

# js = json.loads(file('rankings.js').read()[11:])

print js['time']
for r in js['data']['rankings']:
    if r['team'] == 'Trup16':
        # print r
        print "overall: p:{power_score} rank:{rank:2} score:{score} " \
              "tags:{tags}".format(**r)

total_score = 0
for map_i, map_data in enumerate(js['data']['settings']):
    for md in map_data['rankings']:
        if md['team'] == 'Trup16':
            # print((map_i, md))
            print "{0:2}: power:{power_score} rank:{rank:2} score:{score:5} " \
                "tags:{tags}".format(map_i, **md)
            total_score += md['score']

print 'Total score', total_score
