#!/usr/bin/env python
from datetime import date,datetime,timedelta
import MySQLdb
import sys
import time

import json
import requests
from pprint import pprint
import hashlib




if len(sys.argv)==1:
    print "usage: wordsearch addfile filename|add word|show|run|addslot id seed prefix postfix|rerun word"
    sys.exit(0)

cnx = MySQLdb.connect('◘◘◘◘◘◘◘◘','◘◘◘◘◘◘◘◘','◘◘◘◘◘◘◘◘','icfp2015',port=◘◘◘◘◘◘◘◘)
cursor = cnx.cursor()

def addword(word):
    cursor.execute("""select word,status from words where word="%s" """%word.lower())
    p=cursor.fetchall()
    if p:
        print word, "already exists",p
        return 
    cursor.execute("""insert into words (word,status,tag) values ("%s","new","%s")"""%(word.lower(),hashlib.md5('time.time()'+word.lower()).hexdigest()[:12]))
    cnx.commit();

if sys.argv[1]=='show':
    print 'words'
    cursor.execute("select * from words");
    co=0
    for i in cursor.fetchall():
        print i
        co+=1
    print co, 'total'
    print
    print 'slots'
    cursor.execute("select * from slots");
    co=0
    for i in cursor.fetchall():
        print i
        co+=1
    print co, 'total'
    cursor.execute("select * from words where status like 'POWER%'");
    co=0
    for i in cursor.fetchall():
        print i
        co+=1
    print 'TOTAL POWER',co


elif sys.argv[1]=='rerun':
    cursor.execute("""select word,status from words where word="%s" """%sys.argv[2].lower())
    p=cursor.fetchall()
    if not p:
        print sys.argv[2], "doesn't exist"
    cursor.execute('update words set status ="%s",tag="%s" where word="%s"'%('new',hashlib.md5('time.time()'+sys.argv[2]).hexdigest()[:12],sys.argv[2]))
    cnx.commit();

elif sys.argv[1]=='add':
    addword(sys.argv[2])
elif sys.argv[1]=='addslot':
    cursor.execute("""select taskid,seed from slots where taskid=%s and seed=%s """%(sys.argv[2],sys.argv[3]))
    p=cursor.fetchall()
    if p:
        print word, "already exists",p
    print tuple(sys.argv[2:6])
    cursor.execute("insert into slots (taskid,seed,prefix,postfix) values (%s,%s,'%s','%s')"%tuple(sys.argv[2:6]))
    cnx.commit();
    
elif sys.argv[1]=='addfile':
    for i in file(sys.argv[2]).readlines():
        addword(i)
elif sys.argv[1]=='run':
    while 1:
        print "checking progress in 3"
        time.sleep(1)
        print "checking progress in 2"
        time.sleep(1)
        print "checking progress in 1"
        time.sleep(1)
        
        cursor.execute("select tag from words where status = 'running'")
        tocheck=set(cursor.fetchall())
        todelete=set()
       
        r = requests.get('https://davar.icfpcontest.org/rankings.js')
        print "got rankings"
        js_data = r.content[11:]
        js = json.loads(js_data)
        for map_i, map_data in enumerate(js['data']['settings']):
            for md in map_data['rankings']:
                try:  
                    if md['team'] == 'Trup16':
                        # print((map_i, md))
                        #print "{0:2}: p:{power_score} rank:{rank:2} score:{score:5} " \
                        #    "tags:{tags}".format(map_i, **md)
                        #total_score += md['score']
                        if 'free' in md['tags']:
                            md['tags'].remove('free')
                        
                        
                    
                        if set(map(lambda x:(x,),md['tags'],)) & tocheck:
                            if md['score']=="null":
                                print 'still running',md
                            if md['score']==0:
                                print 'error',md
                                cursor.execute('update words set status="error" where tag="%s"'%md['tags'][0])
                            elif md['power_score']==0:
                                #no luck
                                print "no power",md
                                cursor.execute('update words set status="nopower" where tag="%s"'%md['tags'][0])
                            elif md['power_score']>0:
                                #yay
                                print "found power!"
                                cursor.execute('update words set status="POWER %s" where tag="%s"'%(md['power_score'],md['tags'][0]))
                            else:
                                print "crap",md
                        cnx.commit()
                except:
                    print "shit?"
                    cnx.rollback()
                    raise


        #results = [{'tag':'her','score':0}] #fixme
        #print tocheck
        #for i in results:
        #    if (i['tag'],) in tocheck:
        #        todelete.add((i['tag'],))
        #        if i['score']=="null":
        #            print 'still running',i
        #        if i['score']==0:
        #            cursor.execute('update words set status="error" where tag="%s"'%i['tag'])
        #        elif i['power_score']==0:
        #            #no luck
        #            cursor.execute('update words set status="nopower" where tag="%s"'%i['tag'])
        #        elif i['power_score']>0:
        #            #yay
        #            cursor.execute('update words set status="POWER %s" where tag="%s"'%i['power'],i['tag'])
        #        else:
        #            print i,"crap"
        #for i in tocheck-todelete:
        #    #must be nothing
        #    print i
        #    cursor.execute('update words set status="unexpected" where tag="%s"'%i[0])
        
        cursor.execute("select word,tag from words where status = 'new'")
        words=cursor.fetchall()
        cursor.execute("select taskid,seed,prefix,postfix from slots where not exists (select word from words where words.taskid=slots.taskid and words.status='running')")
        slots=cursor.fetchall()
        print "trying to submit words"
        if slots and words:
            while slots and words:
                word,words=words[0],words[1:]
                slot,slots=slots[0],slots[1:]
                cursor.execute('update words set status="running", taskid=%s where word="%s"'%(int(slot[0]),word[0]))
                print "submitting",word,slot
                try:
                    solutions=[{"problemId":int(slot[0]),"seed":int(slot[1]),"tag":word[1],"solution":slot[2]+word[0]}]
                    url = "https://davar.icfpcontest.org/teams/89/solutions"
                    print "submitting shit:"
                    print solutions
                    resp = requests.post(url,auth=("","Np3qWHN04io/qP4AE81Q98goLH9dgSn9xZEbnaMSoRc="),data=json.dumps(solutions),headers={"Content-type":"application/json"})
                    print resp.content
                    cnx.commit()
                except:
                    #print "got shit",resp.content
                    raise
                    cnx.rollback()
                    
        else:
            print "no free slots or no words" ,slots,"word",words
        print "sleeping"
        time.sleep(20)
else:
    print "usage: wordsearch addfile filename|add word|show|run"
    sys.exit(0)


cursor.close();
cnx.close();